program writeRawBinary

  implicit none
  integer, parameter :: n = 16
  integer :: i, j, k
  real*4, parameter :: pi = 3.141592654
  real*4 :: x, y, z
  real*4, dimension(n,n,n) :: a

  do i = 1, n
     x = (float(i)-0.5)/float(n)
     do j = 1, n
        y = (float(j)-0.5)/float(n)
        do k = 1, n
           z = (float(k)-0.5)/float(n)
!           a(i,j,k) = sin(x*2.*pi)**2 * sin(y*2.*pi)**2 * sin(z*2.*pi)**2
           a(i,j,k) = (1.-z)*((1.-y)*sin(pi*x)+y*sin(2.*pi*x)**2) + &
                z*((1.-x)*sin(pi*y)+x*sin(2.*pi*y)**2)
        enddo
     enddo
  enddo

  open(15,file='simpleData.raw',status='new',form='unformatted')
  write(15) (((a(i,j,k),i=1,n),j=1,n),k=1,n)
  close(15)

end program writeRawBinary
